import React, { DetailedHTMLProps, HTMLAttributes, ReactNode } from 'react';
export type Button = JSX.Element | string | null;
export type SpeechStatus = 'started' | 'paused' | 'stopped';
export interface ChildrenOptions {
    speechStatus?: SpeechStatus;
    start?: Function;
    pause?: Function;
    stop?: Function;
}
export type Children = (childrenOptions: ChildrenOptions) => ReactNode;
export type Props = DetailedHTMLProps<HTMLAttributes<HTMLDivElement>, HTMLDivElement>;
export interface SpeechProps {
    text: string;
    pitch?: number;
    rate?: number;
    volume?: number;
    lang?: string;
    startBtn?: Button;
    pauseBtn?: Button;
    stopBtn?: Button;
    useStopOverPause?: boolean;
    onError?: Function;
    children?: Children;
    props?: Props;
}
export type { IconProps } from './icons.js';
declare function Speech({ text, pitch, rate, volume, lang, startBtn, pauseBtn, stopBtn, useStopOverPause, onError, children, props }: SpeechProps): string | number | boolean | React.JSX.Element | Iterable<React.ReactNode> | null | undefined;
export default Speech;
