import React, { useEffect, useState } from 'react';
import { HiMiniStop, HiVolumeOff, HiVolumeUp } from './icons.js';
function Speech({ text, pitch = 1, rate = 1, volume = 1, lang = '', startBtn = React.createElement(HiVolumeUp, null), pauseBtn = React.createElement(HiVolumeOff, null), stopBtn = React.createElement(HiMiniStop, null), useStopOverPause, onError = () => alert('Browser not supported! Try some other browser.'), children, props = {} }) {
    const [speechStatus, setSpeechStatus] = useState('stopped');
    const [useStop, setUseStop] = useState();
    const pause = () => { var _a; return speechStatus !== 'paused' && ((_a = window.speechSynthesis) === null || _a === void 0 ? void 0 : _a.pause()); };
    const stop = () => { var _a; return speechStatus !== 'stopped' && ((_a = window.speechSynthesis) === null || _a === void 0 ? void 0 : _a.cancel()); };
    function start() {
        const synth = window.speechSynthesis;
        if (!synth)
            return onError();
        setSpeechStatus('started');
        if (speechStatus === 'paused')
            return synth.resume();
        if (synth.speaking)
            synth.cancel();
        const utterance = new window.SpeechSynthesisUtterance(text === null || text === void 0 ? void 0 : text.replace(/\s/g, ' '));
        utterance.pitch = pitch;
        utterance.rate = rate;
        utterance.volume = volume;
        utterance.lang = lang;
        function setStopped() {
            setSpeechStatus('stopped');
            utterance.onpause = null;
            utterance.onend = null;
            utterance.onerror = null;
            if (synth.paused)
                synth.cancel();
        }
        utterance.onpause = () => setSpeechStatus('paused');
        utterance.onend = setStopped;
        utterance.onerror = setStopped;
        synth.speak(utterance);
    }
    function speech() {
        if (speechStatus !== 'started')
            start();
        else if (useStop === false)
            pause();
        else
            stop();
    }
    useEffect(() => {
        var _a, _b;
        setUseStop(useStopOverPause !== null && useStopOverPause !== void 0 ? useStopOverPause : (((_a = navigator.userAgentData) === null || _a === void 0 ? void 0 : _a.mobile) || false));
        (_b = window.speechSynthesis) === null || _b === void 0 ? void 0 : _b.cancel();
    }, []);
    return typeof children === 'function' ? children({ speechStatus, start, pause, stop }) : React.createElement("div", Object.assign({ style: { display: 'flex', columnGap: '1rem' } }, props),
        React.createElement("span", { role: 'button', onClick: speech }, speechStatus !== 'started' ? startBtn : useStop === false ? pauseBtn : stopBtn),
        useStop === false && stopBtn && React.createElement("span", { role: 'button', onClick: stop }, stopBtn));
}
export default Speech;
